Index: sasmodels/models/core_shell_parallelepiped.c
===================================================================
--- sasmodels/models/core_shell_parallelepiped.c	(revision 22221346d45e39a667fe231ce7ca5ecfc79b0ac5)
+++ sasmodels/models/core_shell_parallelepiped.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -35,9 +35,8 @@
     // Did not understand the code completely, it should be rechecked (Miguel Gonzalez)
     
-    double t1, t2, t3, t4, tmp, answer;   
-    double mu = q * length_b;
+    const double mu = 0.5 * q * length_b;
     
     //calculate volume before rescaling (in original code, but not used)
-    //double vol = form_volume(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c);		
+    //double vol = form_volume(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c);        
     //double vol = length_a * length_b * length_c + 
     //       2.0 * thick_rim_a * length_b * length_c + 
@@ -46,76 +45,54 @@
     
     // Scale sides by B
-    double a_scaled = length_a / length_b;
-    double c_scaled = length_c / length_b;
+    const double a_scaled = length_a / length_b;
+    const double c_scaled = length_c / length_b;
 
-    // DelRho values (note that drC is not used later)       
-	double dr0 = core_sld-solvent_sld;
-	double drA = arim_sld-solvent_sld;
-	double drB = brim_sld-solvent_sld;
-	//double drC = crim_sld-solvent_sld;
+    // ta and tb correspond to the definitions in CSPPKernel, but they don't make sense to me (MG)
+    // the a_scaled in the definition of tb was present in CSPPKernel in libCylinder.c,
+    // while in cspkernel in csparallelepiped.cpp (used for the 2D), all the definitions
+    // for ta, tb, tc use also A + 2*rim_thickness (but not scaled by B!!!)
+    double ta = (a_scaled + 2.0*thick_rim_a)/length_b;
+    double tb = (a_scaled + 2.0*thick_rim_b)/length_b;
 
-    //Order of integration
-    int nordi=76;			        
-    int nordj=76;
-    
-    // outer integral (with nordi gauss points), integration limits = 0, 1
-    double summ = 0; //initialize integral
+    double Vin = length_a * length_b * length_c;
+    //double Vot = (length_a * length_b * length_c +
+    //            2.0 * thick_rim_a * length_b * length_c +
+    //            2.0 * length_a * thick_rim_b * length_c +
+    //            2.0 * length_a * length_b * thick_rim_c);
+    double V1 = (2.0 * thick_rim_a * length_b * length_c);    // incorrect V1 (aa*bb*cc+2*ta*bb*cc)
+    double V2 = (2.0 * length_a * thick_rim_b * length_c);    // incorrect V2(aa*bb*cc+2*aa*tb*cc)
 
-    for( int i=0; i<nordi; i++) {
-		
-        // inner integral (with nordj gauss points), integration limits = 0, 1
-	
-        double summj = 0.0;
-	    double sigma = 0.5 * ( Gauss76Z[i] + 1.0 );		
-		
-	    for(int j=0; j<nordj; j++) {
+    // Scale factors (note that drC is not used later)
+    const double drho0 = (core_sld-solvent_sld);
+    const double drhoA = (arim_sld-solvent_sld);
+    const double drhoB = (brim_sld-solvent_sld);
+    //const double drC_Vot = (crim_sld-solvent_sld)*Vot;
 
-            double uu = 0.5 * ( Gauss76Z[j] + 1.0 );
-            double mudum = mu * sqrt(1.0-sigma*sigma);
+    // Precompute scale factors for combining cross terms from the shape
+    const double scale23 = drhoA*V1;
+    const double scale14 = drhoB*V2;
+    const double scale12 = drho0*Vin - scale23 - scale14;
 
-	        double Vin = length_a * length_b * length_c;
-	        //double Vot = (length_a * length_b * length_c +
-            //            2.0 * thick_rim_a * length_b * length_c +
-            //            2.0 * length_a * thick_rim_b * length_c +
-            //            2.0 * length_a * length_b * thick_rim_c);
-	        double V1 = (2.0 * thick_rim_a * length_b * length_c);    // incorrect V1 (aa*bb*cc+2*ta*bb*cc)
-	        double V2 = (2.0 * length_a * thick_rim_b * length_c);    // incorrect V2(aa*bb*cc+2*aa*tb*cc)
-	
-            // ta and tb correspond to the definitions in CSPPKernel, but they don't make sense to me (MG)
-            // the a_scaled in the definition of tb was present in CSPPKernel in libCylinder.c,
-            // while in cspkernel in csparallelepiped.cpp (used for the 2D), all the definitions
-            // for ta, tb, tc use also A + 2*rim_thickness (but not scaled by B!!!)            
-            double ta = (a_scaled+2.0*thick_rim_a)/length_b; 
-            double tb = (a_scaled+2.0*thick_rim_b)/length_b;
-    
-	        double arg1 = (0.5*mudum*a_scaled) * sin(0.5*M_PI*uu);
-	        double arg2 = (0.5*mudum) * cos(0.5*M_PI*uu);
-	        double arg3=  (0.5*mudum*ta) * sin(0.5*M_PI*uu);
-	        double arg4=  (0.5*mudum*tb) * cos(0.5*M_PI*uu);
+    // outer integral (with gauss points), integration limits = 0, 1
+    double outer_total = 0; //initialize integral
 
-	        if(arg1==0.0){
-		        t1 = 1.0;
-	        } else {
-		        t1 = (sin(arg1)/arg1);                //defn for CSPP model sin(arg1)/arg1    test:  (sin(arg1)/arg1)*(sin(arg1)/arg1)   
-	        }
-	        if(arg2==0.0){
-		        t2 = 1.0;
-	        } else {
-		        t2 = (sin(arg2)/arg2);           //defn for CSPP model sin(arg2)/arg2   test: (sin(arg2)/arg2)*(sin(arg2)/arg2)    
-	        }	
-	        if(arg3==0.0){
-		        t3 = 1.0;
-	        } else {
-		        t3 = sin(arg3)/arg3;
-	        }
-	        if(arg4==0.0){
-		        t4 = 1.0;
-	        } else {
-		        t4 = sin(arg4)/arg4;
-	        }
-            
+    for( int i=0; i<76; i++) {
+        double sigma = 0.5 * ( Gauss76Z[i] + 1.0 );
+        double mu_proj = mu * sqrt(1.0-sigma*sigma);
+
+        // inner integral (with gauss points), integration limits = 0, 1
+        double inner_total = 0.0;
+        for(int j=0; j<76; j++) {
+            const double uu = 0.5 * ( Gauss76Z[j] + 1.0 );
+            double sin_uu, cos_uu;
+            SINCOS(M_PI_2*uu, sin_uu, cos_uu);
+            const double si1 = sas_sinx_x(mu_proj * sin_uu * a_scaled);
+            const double si2 = sas_sinx_x(mu_proj * cos_uu);
+            const double si3 = sas_sinx_x(mu_proj * sin_uu * ta);
+            const double si4 = sas_sinx_x(mu_proj * cos_uu * tb);
+
             // Expression in libCylinder.c (neither drC nor Vot are used)
-	        tmp =( dr0*t1*t2*Vin + drA*(t3-t1)*t2*V1+ drB*t1*(t4-t2)*V2 )*( dr0*t1*t2*Vin + drA*(t3-t1)*t2*V1+ drB*t1*(t4-t2)*V2 );   //  correct FF : square of sum of phase factors            
-            
+            const double form = scale12*si1*si2 + scale23*si2*si3 + scale14*si1*si4;
+
             // To note also that in csparallelepiped.cpp, there is a function called
             // cspkernel, which seems to make more sense and has the following comment:
@@ -126,30 +103,17 @@
             // while CSParallelepipedModel calls CSParallelepiped in libCylinder.c        
             
-            summj += Gauss76Wt[j] * tmp;
+            //  correct FF : sum of square of phase factors
+            inner_total += Gauss76Wt[j] * form * form;
+        }
+        inner_total *= 0.5;
 
-        }
-		
-        // value of the inner integral
-        answer = 0.5 * summj;
+        // now sum up the outer integral
+        const double si = sas_sinx_x(mu * c_scaled * sigma);
+        outer_total += Gauss76Wt[i] * inner_total * si * si;
+    }
+    outer_total *= 0.5;
 
-		// finish the outer integral 
-		double arg = 0.5 * mu* c_scaled *sigma;
-		if ( arg == 0.0 ) {
-			answer *= 1.0;
-		} else {
-	        answer *= sin(arg)*sin(arg)/arg/arg;
-		}
-		
-		// now sum up the outer integral
-		summ += Gauss76Wt[i] * answer;
-
-    }
-    
-	answer = 0.5 * summ;
-
-	//convert from [1e-12 A-1] to [cm-1]
-	answer *= 1.0e-4;
-	
-	return answer;
+    //convert from [1e-12 A-1] to [cm-1]
+    return 1.0e-4 * outer_total;
 }
 
@@ -170,109 +134,44 @@
     double psi)
 {
-    double tmp1, tmp2, tmp3, tmpt1, tmpt2, tmpt3;   
+    double q, cos_val_a, cos_val_b, cos_val_c;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_val_c, cos_val_b, cos_val_a);
 
-    double q = sqrt(qx*qx+qy*qy);
-    double qx_scaled = qx/q;
-    double qy_scaled = qy/q;
+    // cspkernel in csparallelepiped recoded here
+    const double dr0 = core_sld-solvent_sld;
+    const double drA = arim_sld-solvent_sld;
+    const double drB = brim_sld-solvent_sld;
+    const double drC = crim_sld-solvent_sld;
 
-    // Convert angles given in degrees to radians
-    theta *= M_PI_180;
-    phi   *= M_PI_180;
-    psi   *= M_PI_180;
-    
-    // Parallelepiped c axis orientation
-    double cparallel_x = cos(theta) * cos(phi);
-    double cparallel_y = sin(theta);
-    
-    // Compute angle between q and parallelepiped axis
-    double cos_val_c = cparallel_x*qx_scaled + cparallel_y*qy_scaled;// + cparallel_z*qz;
-
-    // Parallelepiped a axis orientation
-    double parallel_x = -cos(phi)*sin(psi) * sin(theta)+sin(phi)*cos(psi);
-    double parallel_y = sin(psi)*cos(theta);
-    double cos_val_a = parallel_x*qx_scaled + parallel_y*qy_scaled;
-
-    // Parallelepiped b axis orientation
-    double bparallel_x = -sin(theta)*cos(psi)*cos(phi)-sin(psi)*sin(phi);
-    double bparallel_y = cos(theta)*cos(psi);
-    double cos_val_b = bparallel_x*qx_scaled + bparallel_y*qy_scaled;
-
-    // The following tests should always pass
-    if (fabs(cos_val_c)>1.0) {
-      //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val_c = 1.0;
-    }
-    if (fabs(cos_val_a)>1.0) {
-      //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val_a = 1.0;
-    }
-    if (fabs(cos_val_b)>1.0) {
-      //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val_b = 1.0;
-    }
-    
-    // cspkernel in csparallelepiped recoded here 
-    double dr0 = core_sld-solvent_sld;
-	double drA = arim_sld-solvent_sld;
-	double drB = brim_sld-solvent_sld;
-	double drC = crim_sld-solvent_sld;
-	double Vin = length_a * length_b * length_c;
+    double Vin = length_a * length_b * length_c;
+    double V1 = 2.0 * thick_rim_a * length_b * length_c;    // incorrect V1(aa*bb*cc+2*ta*bb*cc)
+    double V2 = 2.0 * length_a * thick_rim_b * length_c;    // incorrect V2(aa*bb*cc+2*aa*tb*cc)
+    double V3 = 2.0 * length_a * length_b * thick_rim_c;
     // As for the 1D case, Vot is not used
-	//double Vot = (length_a * length_b * length_c +
+    //double Vot = (length_a * length_b * length_c +
     //              2.0 * thick_rim_a * length_b * length_c +
     //              2.0 * length_a * thick_rim_b * length_c +
     //              2.0 * length_a * length_b * thick_rim_c);
-	double V1 = (2.0 * thick_rim_a * length_b * length_c);    // incorrect V1 (aa*bb*cc+2*ta*bb*cc)
-	double V2 = (2.0 * length_a * thick_rim_b * length_c);    // incorrect V2(aa*bb*cc+2*aa*tb*cc)
-    double V3 = (2.0 * length_a * length_b * thick_rim_c);
+
     // The definitions of ta, tb, tc are not the same as in the 1D case because there is no
     // the scaling by B. The use of length_a for the 3 of them seems clearly a mistake to me,
     // but for the moment I let it like this until understanding better the code.
-	double ta = length_a + 2.0*thick_rim_a;
+    double ta = length_a + 2.0*thick_rim_a;
     double tb = length_a + 2.0*thick_rim_b;
     double tc = length_a + 2.0*thick_rim_c;
     //handle arg=0 separately, as sin(t)/t -> 1 as t->0
-    double argA = 0.5*q*length_a*cos_val_a;
-    double argB = 0.5*q*length_b*cos_val_b;
-    double argC = 0.5*q*length_c*cos_val_c;
-    double argtA = 0.5*q*ta*cos_val_a;
-    double argtB = 0.5*q*tb*cos_val_b;
-    double argtC = 0.5*q*tc*cos_val_c;
+    double siA = sas_sinx_x(0.5*q*length_a*cos_val_a);
+    double siB = sas_sinx_x(0.5*q*length_b*cos_val_b);
+    double siC = sas_sinx_x(0.5*q*length_c*cos_val_c);
+    double siAt = sas_sinx_x(0.5*q*ta*cos_val_a);
+    double siBt = sas_sinx_x(0.5*q*tb*cos_val_b);
+    double siCt = sas_sinx_x(0.5*q*tc*cos_val_c);
     
-    if(argA==0.0) {
-        tmp1 = 1.0;
-    } else {
-        tmp1 = sin(argA)/argA;
-    }
-    if (argB==0.0) {
-        tmp2 = 1.0;
-    } else {
-        tmp2 = sin(argB)/argB;
-    }
-    if (argC==0.0) {
-        tmp3 = 1.0;
-    } else {
-        tmp3 = sin(argC)/argC;
-    }
-    if(argtA==0.0) {
-        tmpt1 = 1.0;
-    } else {
-        tmpt1 = sin(argtA)/argtA;
-    }
-    if (argtB==0.0) {
-        tmpt2 = 1.0;
-    } else {
-        tmpt2 = sin(argtB)/argtB;
-    }
-    if (argtC==0.0) {
-        tmpt3 = 1.0;
-    } else {
-        tmpt3 = sin(argtC)*sin(argtC)/argtC/argtC;
-    }
 
     // f uses Vin, V1, V2, and V3 and it seems to have more sense than the value computed
     // in the 1D code, but should be checked!
-    double f = ( dr0*tmp1*tmp2*tmp3*Vin + drA*(tmpt1-tmp1)*tmp2*tmp3*V1 + 
-               drB*tmp1*(tmpt2-tmp2)*tmp3*V2 + drC*tmp1*tmp2*(tmpt3-tmp3)*V3);
+    double f = ( dr0*siA*siB*siC*Vin
+               + drA*(siAt-siA)*siB*siC*V1
+               + drB*siA*(siBt-siB)*siC*V2
+               + drC*siA*siB*(siCt*siCt-siC)*V3);
    
     return 1.0e-4 * f * f;
Index: sasmodels/models/core_shell_parallelepiped.py
===================================================================
--- sasmodels/models/core_shell_parallelepiped.py	(revision 22221346d45e39a667fe231ce7ca5ecfc79b0ac5)
+++ sasmodels/models/core_shell_parallelepiped.py	(revision 5810f00b5c1f61f1386ab0be011468bf48fbf8c0)
@@ -1,5 +1,6 @@
-# core_shell_parallelepiped model
-# Note: model title and parameter table are inserted automatically
 r"""
+Definition
+----------
+
 Calculates the form factor for a rectangular solid with a core-shell structure.
 **The thickness and the scattering length density of the shell or "rim"
@@ -15,9 +16,4 @@
 of the rectangular solid.
 
-An instrument resolution smeared version of the model is also provided.
-
-
-Definition
-----------
 
 The function calculated is the form factor of the rectangular solid below.
@@ -41,17 +37,29 @@
 **meaning that there are "gaps" at the corners of the solid.**
 
-The intensity calculated follows the :ref:`parallelepiped` model, with the core-shell
-intensity being calculated as the square of the sum of the amplitudes of the
-core and shell, in the same manner as a core-shell model.
-
-**For the calculation of the form factor to be valid, the sides of the solid
-MUST be chosen such that** $A < B < C$.
-**If this inequality is not satisfied, the model will not report an error,
-and the calculation will not be correct.**
+The intensity calculated follows the :ref:`parallelepiped` model, with the
+core-shell intensity being calculated as the square of the sum of the
+amplitudes of the core and shell, in the same manner as a core-shell model.
+
+.. math::
+
+    F_{a}(Q,\alpha,\beta)=
+    \Bigg(\frac{sin(Q(L_A+2t_A)/2sin\alpha sin\beta)}{Q(L_A+2t_A)/2sin\alpha
+    sin\beta)}
+    - \frac{sin(QL_A/2sin\alpha sin\beta)}{QL_A/2sin\alpha sin\beta)} \Bigg)
+    + \frac{sin(QL_B/2sin\alpha sin\beta)}{QL_B/2sin\alpha sin\beta)}
+    + \frac{sin(QL_C/2sin\alpha sin\beta)}{QL_C/2sin\alpha sin\beta)}
+
+.. note::
+
+    For the calculation of the form factor to be valid, the sides of the solid
+    MUST be chosen such that** $A < B < C$.
+    If this inequality is not satisfied, the model will not report an error,
+    but the calculation will not be correct and thus the result wrong.
 
 FITTING NOTES
 If the scale is set equal to the particle volume fraction, |phi|, the returned
 value is the scattered intensity per unit volume, $I(q) = \phi P(q)$.
-However, **no interparticle interference effects are included in this calculation.**
+However, **no interparticle interference effects are included in this
+calculation.**
 
 There are many parameters in this model. Hold as many fixed as possible with
@@ -68,8 +76,4 @@
 and length $(C+2t_C)$ values, and used as the effective radius
 for $S(Q)$ when $P(Q) * S(Q)$ is applied.
-
-.. Comment by Miguel Gonzalez:
-   The later seems to contradict the previous statement that interparticle interference
-   effects are not included.
 
 To provide easy access to the orientation of the parallelepiped, we define the
@@ -98,7 +102,17 @@
 ----------
 
-P Mittelbach and G Porod, *Acta Physica Austriaca*, 14 (1961) 185-211
-Equations (1), (13-14). (in German)
-
+.. [#] P Mittelbach and G Porod, *Acta Physica Austriaca*, 14 (1961) 185-211
+    Equations (1), (13-14). (in German)
+.. [#] D Singh (2009). *Small angle scattering studies of self assembly in
+   lipid mixtures*, John's Hopkins University Thesis (2009) 223-225. `Available
+   from Proquest <http://search.proquest.com/docview/304915826?accountid
+   =26379>`_
+
+Authorship and Verification
+----------------------------
+
+* **Author:** NIST IGOR/DANSE **Date:** pre 2010
+* **Last Modified by:** Paul Butler **Date:** September 30, 2016
+* **Last Reviewed by:** Miguel Gonzales **Date:** March 21, 2016
 """
 
@@ -164,6 +178,5 @@
 # parameters for demo
 demo = dict(scale=1, background=0.0,
-            sld_core=1e-6, sld_a=2e-6, sld_b=4e-6,
-            sld_c=2e-6, sld_solvent=6e-6,
+            sld_core=1, sld_a=2, sld_b=4, sld_c=2, sld_solvent=6,
             length_a=35, length_b=75, length_c=400,
             thick_rim_a=10, thick_rim_b=10, thick_rim_c=10,
@@ -177,5 +190,5 @@
             theta_pd=10, theta_pd_n=1,
             phi_pd=10, phi_pd_n=1,
-            psi_pd=10, psi_pd_n=10)
+            psi_pd=10, psi_pd_n=1)
 
 qx, qy = 0.2 * np.cos(2.5), 0.2 * np.sin(2.5)
Index: sasmodels/models/core_shell_sphere.c
===================================================================
--- sasmodels/models/core_shell_sphere.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/core_shell_sphere.c	(revision 3a48772f136eb2795903c63707474e7527b4a325)
@@ -16,4 +16,4 @@
 double form_volume(double radius, double thickness)
 {
-    return 4.0 * M_PI / 3.0 * pow((radius + thickness), 3);
+    return M_4PI_3 * cube(radius + thickness);
 }
Index: sasmodels/models/core_shell_sphere.py
===================================================================
--- sasmodels/models/core_shell_sphere.py	(revision 9a4811ac2bdb93459d640d111cba9f1016660790)
+++ sasmodels/models/core_shell_sphere.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -75,5 +75,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/core_shell.c", "core_shell_sphere.c"]
+source = ["lib/sas_3j1x_x.c", "lib/core_shell.c", "core_shell_sphere.c"]
 
 demo = dict(scale=1, background=0, radius=60, thickness=10,
@@ -95,6 +95,6 @@
     """
     return (1, 1)
-    whole = 4.0 * pi / 3.0 * pow((radius + thickness), 3)
-    core = 4.0 * pi / 3.0 * radius * radius * radius
+    whole = 4.0/3.0 * pi * (radius + thickness)**3
+    core = 4.0/3.0 * pi * radius**3
     return whole, whole - core
 
Index: sasmodels/models/cylinder.c
===================================================================
--- sasmodels/models/cylinder.c	(revision 9cc7fca27a737c4942602927eb564d8c20db58e0)
+++ sasmodels/models/cylinder.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -18,5 +18,5 @@
     const double qr = q*radius;
     const double qh = q*0.5*length; 
-    return  sas_J1c(qr*sn) * sinc(qh*cn) ;
+    return sas_2J1x_x(qr*sn) * sas_sinx_x(qh*cn);
 }
 
@@ -58,15 +58,9 @@
     double phi)
 {
-    double sn, cn; // slots to hold sincos function output
-
-    // Compute angle alpha between q and the cylinder axis
-    SINCOS(phi*M_PI_180, sn, cn);
-    const double q = sqrt(qx*qx + qy*qy);
-    const double cos_val = (q==0. ? 1.0 : (cn*qx + sn*qy)*sin(theta*M_PI_180)/q);
-
-    const double alpha = acos(cos_val);
-
-    SINCOS(alpha, sn, cn);
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
+    //printf("sn: %g cn: %g\n", sin_alpha, cos_alpha);
     const double s = (sld-solvent_sld) * form_volume(radius, length);
-    return 1.0e-4 * square(s * fq(q, sn, cn, radius, length));
+    const double form = fq(q, sin_alpha, cos_alpha, radius, length);
+    return 1.0e-4 * square(s * form);
 }
Index: sasmodels/models/cylinder.py
===================================================================
--- sasmodels/models/cylinder.py	(revision 4cdd0cc83e644cfa2cf6045c86fd32ccd5ccf2ef)
+++ sasmodels/models/cylinder.py	(revision b7e8b94b477e6d9a7e4e2666bb218d3568ee66d2)
@@ -2,5 +2,5 @@
 # Note: model title and parameter table are inserted automatically
 r"""
-The form factor is normalized by the particle volume V = \piR^2L.
+
 For information about polarised and magnetic scattering, see
 the :ref:`magnetism` documentation.
@@ -14,5 +14,5 @@
 .. math::
 
-    P(q,\alpha) = \frac{\text{scale}}{V} F^2(q,\alpha) + \text{background}
+    P(q,\alpha) = \frac{\text{scale}}{V} F^2(q,\alpha).sin(\alpha) + \text{background}
 
 where
@@ -25,5 +25,5 @@
            \frac{J_1 \left(q R \sin \alpha\right)}{q R \sin \alpha}
 
-and $\alpha$ is the angle between the axis of the cylinder and $\vec q$, $V$
+and $\alpha$ is the angle between the axis of the cylinder and $\vec q$, $V =\pi R^2L$
 is the volume of the cylinder, $L$ is the length of the cylinder, $R$ is the
 radius of the cylinder, and $\Delta\rho$ (contrast) is the scattering length
@@ -35,9 +35,26 @@
 .. math::
 
-    F^2(q)=\int_{0}^{\pi/2}{F^2(q,\theta)\sin(\theta)d\theta}
+    F^2(q)=\int_{0}^{\pi/2}{F^2(q,\alpha)\sin(\alpha)d\alpha}=\int_{0}^{1}{F^2(q,u)du}
 
 
-To provide easy access to the orientation of the cylinder, we define the
-axis of the cylinder using two angles $\theta$ and $\phi$. Those angles
+Numerical integration is simplified by a change of variable to $u = cos(\alpha)$ with 
+$sin(\alpha)=\sqrt{1-u^2}$. 
+
+The output of the 1D scattering intensity function for randomly oriented
+cylinders is thus given by
+
+.. math::
+
+    P(q) = \frac{\text{scale}}{V}
+        \int_0^{\pi/2} F^2(q,\alpha) \sin \alpha\ d\alpha + \text{background}
+
+
+NB: The 2nd virial coefficient of the cylinder is calculated based on the
+radius and length values, and used as the effective radius for $S(q)$
+when $P(q) \cdot S(q)$ is applied.
+
+For oriented cylinders, we define the direction of the
+axis of the cylinder using two angles $\theta$ (note this is not the
+same as the scattering angle used in q) and $\phi$. Those angles
 are defined in :numref:`cylinder-angle-definition` .
 
@@ -48,18 +65,5 @@
     Definition of the angles for oriented cylinders.
 
-
-NB: The 2nd virial coefficient of the cylinder is calculated based on the
-radius and length values, and used as the effective radius for $S(q)$
-when $P(q) \cdot S(q)$ is applied.
-
-The output of the 1D scattering intensity function for randomly oriented
-cylinders is then given by
-
-.. math::
-
-    P(q) = \frac{\text{scale}}{V}
-        \int_0^{\pi/2} F^2(q,\alpha) \sin \alpha\ d\alpha + \text{background}
-
-The $\theta$ and $\phi$ parameters are not used for the 1D output.
+The $\theta$ and $\phi$ parameters only appear in the model when fitting 2d data.
 
 Validation
@@ -74,9 +78,9 @@
 
     P(q) = \int_0^{\pi/2} d\phi
-        \int_0^\pi p(\alpha) P_0(q,\alpha) \sin \alpha\ d\alpha
+        \int_0^\pi p(\theta) P_0(q,\theta) \sin \theta\ d\theta
 
 
 where $p(\theta,\phi) = 1$ is the probability distribution for the orientation
-and $P_0(q,\alpha)$ is the scattering intensity for the fully oriented
+and $P_0(q,\theta)$ is the scattering intensity for the fully oriented
 system, and then comparing to the 1D result.
 
@@ -145,10 +149,13 @@
 
 qx, qy = 0.2 * np.cos(2.5), 0.2 * np.sin(2.5)
-# After redefinition of angles, find new tests values 
-#tests = [[{}, 0.2, 0.042761386790780453],
-#         [{}, [0.2], [0.042761386790780453]],
-#         [{'theta':10.0, 'phi':10.0}, (qx, qy), 0.03514647218513852],
-#         [{'theta':10.0, 'phi':10.0}, [(qx, qy)], [0.03514647218513852]],
-#        ]
+# After redefinition of angles, find new tests values.  Was 10 10 in old coords
+tests = [[{}, 0.2, 0.042761386790780453],
+        [{}, [0.2], [0.042761386790780453]],
+#  new coords    
+        [{'theta':80.1534480601659, 'phi':10.1510817110481}, (qx, qy), 0.03514647218513852],
+        [{'theta':80.1534480601659, 'phi':10.1510817110481}, [(qx, qy)], [0.03514647218513852]],
+# old coords   [{'theta':10.0, 'phi':10.0}, (qx, qy), 0.03514647218513852],
+#              [{'theta':10.0, 'phi':10.0}, [(qx, qy)], [0.03514647218513852]],
+        ]
 del qx, qy  # not necessary to delete, but cleaner
 # ADDED by:  RKH  ON: 18Mar2016 renamed sld's etc
Index: sasmodels/models/dab.py
===================================================================
--- sasmodels/models/dab.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/dab.py	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -59,6 +59,6 @@
 
 Iq = """
-    double numerator   = pow(cor_length, 3);
-    double denominator = pow(1 + pow(q*cor_length,2), 2);
+    double numerator   = cube(cor_length);
+    double denominator = square(1 + square(q*cor_length));
     
     return numerator / denominator ;
Index: sasmodels/models/ellipsoid.c
===================================================================
--- sasmodels/models/ellipsoid.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/ellipsoid.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -8,7 +8,15 @@
 {
     double ratio = radius_polar/radius_equatorial;
-    const double u = q*radius_equatorial*sqrt(1.0
-                   + sin_alpha*sin_alpha*(ratio*ratio - 1.0));
-    const double f = sph_j1c(u);
+    // Given the following under the radical:
+    //     1 + sin^2(T) (v^2 - 1)
+    // we can expand to match the form given in Guinier (1955)
+    //     = (1 - sin^2(T)) + v^2 sin^2(T) = cos^2(T) + sin^2(T)
+    // Instead of using pythagoras we could pass in sin and cos; this may be
+    // slightly better for 2D which has already computed it, but it introduces
+    // an extra sqrt and square for 1-D not required by the current form, so
+    // leave it as is.
+    const double r = radius_equatorial
+                     * sqrt(1.0 + sin_alpha*sin_alpha*(ratio*ratio - 1.0));
+    const double f = sas_3j1x_x(q*r);
 
     return f*f;
@@ -49,12 +57,7 @@
     double phi)
 {
-    double sn, cn;
-
-    const double q = sqrt(qx*qx + qy*qy);
-    SINCOS(phi*M_PI_180, sn, cn);
-    const double cos_alpha = (q==0. ? 1.0 : (cn*qx + sn*qy)*sin(theta*M_PI_180)/q);
-    const double alpha = acos(cos_alpha);
-    SINCOS(alpha, sn, cn);
-    const double form = _ellipsoid_kernel(q, radius_polar, radius_equatorial, sn);
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
+    const double form = _ellipsoid_kernel(q, radius_polar, radius_equatorial, sin_alpha);
     const double s = (sld - sld_solvent) * form_volume(radius_polar, radius_equatorial);
 
Index: sasmodels/models/ellipsoid.py
===================================================================
--- sasmodels/models/ellipsoid.py	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/ellipsoid.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -135,5 +135,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "lib/gauss76.c", "ellipsoid.c"]
+source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "ellipsoid.c"]
 
 def ER(radius_polar, radius_equatorial):
